//Part of XDBEngine source code.
//Version 1.0
//Created by Tomas Koutny.
//for more info see http://www.rawos.cz/xdbe/index.html
//This file is public domain.

//definitions of objects that will be used at interface level of XDBEngine's
//components when devoloping new main engine or database driver
unit EngineLevel;

interface

uses UserLevel, windows, UserStructs, stream64;

const
     //name of procedure that registers filters
     RegisterFunctionName = 'RegisterXDBFilters';

type
    TAXEngine = class;
    TAFilter = class;

    //procedure that registers filters of supported dlls
    TRegisterProc = procedure(Caller:TAXEngine);

    TAXEngine = class(TXDBEngine)
                public
                  procedure RegisterFilter(Filter:TAFilter); dynamic; abstract;
                            //registers new filter for one kind of database
                            //Filter must point to object TFilter
                            //TAXEngine must free Filter from memory
                            //when Filter isn't needed
                  procedure SetLastError(NewCode:integer); dynamic; abstract;
                  function CreateCacheStream(AStream:TStream64):TStream64;
                                                              dynamic; abstract;
                        //this function can be used to create stream that
                        //will use cache of TAXEngine
                        //AStream will control access to medium
                        //and caller must use only returned value
                        //XDB Engine will automatically free AStream
                        //at call returned.Free
                end;


    TAFilter = class(TFilter)
               public
                 function InstanceCreator(AOwner:TAXEngine; DBName:String;
                                          CreateIt:Boolean): TXDBase; virtual; abstract;
                          //creates instance of object representing the databse
                 function Info:TFilterInfo; virtual; abstract; //filter's info
               end;


implementation

end.
