//Part of XDBEngine source code.
//Version 1.2
//Created by Tomas Koutny.
//for more info see http://www.rawos.cz/xdbe/index.html
//This file is public domain.


//definitions of user data types and constants
unit UserStructs;

interface

const
    //constats identifying db data typesd
    xdbdtRawData  = 0;
    xdbdtInteger  = 1;
    xdbdtReal     = 2;
    xdbdtBoolean  = 3;
    xdbdtCurrency = 4;
    xdbdtDateTime = 5;
    xdbdtText     = 6;

    xdbdtDTDefined = 7; //count of implicit defined db data types


    //constants identifying format family
    xdeffXDB = 0;               //.XDB format

    //constants identifying .XDB format implementation
    xdbfi07 = 0;                //version 0.7 implemenation


type
    PByte = ^Byte;
    PDouble = ^Double;


    PIndexData = ^TIndexData;
    TIndexData = array of pointer;

    PFIlterInfo = ^TFilterInfo;
    TFilterInfo = record
                    loVersion, hiVersion:word;
                    CanImport, CanExport:boolean;
                    FormatFamily,     //indicates db file format
                    FormatID:Int64;   //indicates db file format implementation
                    Name,
                    ImportName,
                    ImportMask,
                    ExportName,
                    ExportMask:string;
                    Flags:LongWord;
                  end;

    PColumnDesignTX = ^TColumnDesignTX;
    TColumnDesignTX = record
                        Name:WideString;
                        Kind:Int64;
                        Comment,
                        InputMask,
                        OutputMask:WideString;
                        MinLength,
                        MaxLength:Int64;
                        MinValue,
                        MaxValue,
                        InitialValue:WideString;
                      end;
    TColDesignsTX = array of TColumnDesignTX;

implementation

end.



   
