//Part of XDB Core source code.
//Version 1.1
//Created by Tomas Koutny.
//for more info see http://www.rawos.cz/xdbe/index.html


//realization of function used to register XDB filter
unit Main;

interface

uses UserLevel, EngineLevel, AbstractLayer, UserStructs;

procedure RegisterXDBFilters(Caller:TAXEngine);   //registration procedure

implementation


uses FileLevel, UserConsts, XDBRetCodes;

type
    TXDBCore = class(TAFilter)
                 public
                   function InstanceCreator(AOwner:TAXEngine; DBName:String;
                                            CreateIt:Boolean):TXDBase; override;
                   function Info:TFilterInfo; override;
                   function IOCtl(Code:Integer; Data:pointer):integer; override;
                        //executes with specific operation
                        //Code - number of operation
                        //Data - points to data needed to operation
                        //       when Data = nil only tests if Code is supported
                        //returns zero if operation succesfull or operation
                        //is supported else returns non-zero value
                 end;


procedure RegisterXDBFilters(Caller:TAXEngine);
begin
  Caller.RegisterFilter(TXDBCore.Create);
end;

function TXDBCore.InstanceCreator(AOwner:TAXEngine; DBName:String;
                                                     CreateIt:Boolean):TXDBase;
begin
  try
    result:=TXDBFile.Create(AOwner, DBName, CreateIt);
    AOwner.SetLastError(xdbrcOK);
  except
    result:=nil;
    AOwner.SetLastError(xdbrcCannotCreateDB);
  end;
end;

function TXDBCore.Info:TFilterInfo;
begin
  with result do
    begin
      loVersion:=0;
      hiVersion:=1;
      FormatFamily:=xdeffXDB;
      FormatID:=xdbfi07;
      Name:='Database driver for .XDB files';
      ImportName:='Database XDB (*.XDB)';
      ImportMask:='*.XDB';
      ExportName:='Database XDB (*.XDB)';
      ExportMask:='*.XDB';
      CanImport:=true;
      CanExport:=true;
      Flags:=fsNaming or NTCF;
    end;
end;

function TXDBCore.IOCtl(Code:Integer; Data:pointer):integer;
begin
  result:=-1;         //nothing is currently supported
end;

end.
