//Part of XDB Core source code.
//Version 1.0
//Created by Tomas Koutny.
//for more info see http://www.rawos.cz/xdbe/index.html


//various routines for various units
unit routines;

interface

uses Stream64;

procedure WriteWideString(Where:TStream64; What:WideString);
        //writes WideString into stream and before it writes count of
        //its length in bytes as Int64

function ReadWideString(From:TStream64):WideString; //reverse WriteWideString


function KillSpaces(Arg:WideString):WideString;
        //returns Arg without spaces and underscores


implementation

procedure WriteWideString(Where:TStream64; What:WideString);
        //writes WideString into stream and before it writes count of
        //its length in bytes as Int64
var pom:Int64;
begin
  pom:=Length(What) shl 1;
  Where.Write(pom, 8);
  if pom>0 then Where.Write(pointer(What)^, pom);
end;

function ReadWideString(From:TStream64):WideString; //reverse WriteWideString
var pom:Int64;
begin
  From.Read(pom, 8);
  SetLength(Result, pom shr 1);
          if pom>0 then From.Read(pointer(result)^, pom);
end;

function KillSpaces(Arg:WideString):WideString;
                                //returns Arg without spaces and underscores
var i:integer;
begin
  result:='';
  for i:=1 to Length(Arg) do
     if (Arg[i]<>'') and (Arg[i]<>'_') then result:=result+Arg[i];
end;

end.
