//Part of XDBEngine source code.
//Version 1.0
//Created by Tomas Koutny.
//for more info see http://www.rawos.com/xdbe/index.html


//creating of objects representing whole database kernel
library XDBEngine;

{ Important note about DLL memory management: ShareMem must be the
  first unit in your library's USES clause AND your project's (select
  Project-View Source) USES clause if your DLL exports any procedures or
  functions that pass strings as parameters or function results. This
  applies to all strings passed to and from your DLL--even those that
  are nested in records and classes. ShareMem is the interface unit to
  the BORLNDMM.DLL shared memory manager, which must be deployed along
  with your DLL. To avoid using BORLNDMM.DLL, pass string information
  using PChar or ShortString parameters. }

{$R 'localized\US English\LStrings.res' 'localized\US English\LStrings.RC'}

uses
  ShareMem,
  SysUtils,
  Classes,
  UserStructs in '..\COMMON\UserStructs.pas',
  UserLevel in '..\COMMON\UserLevel.pas',
  EngineLevel in '..\COMMON\EngineLevel.pas',
  Main in 'Main.pas',
  XDBRetCodes in '..\COMMON\XDBRetCodes.pas',
  stream64 in '..\..\..\common\stream64.pas',
  CachePages in 'CachePages.pas',
  CacheStreams in 'CacheStreams.pas',
  AbstractLayer in 'AbstractLayer.pas',
  BTree in '..\..\..\common\BTree.pas',
  LResIds in 'LResIds.pas',
  routines in 'routines.pas';

{$R *.RES}

//we will export only one function
//if CacheSize = 0 then engine uses system cache
function CreateXDBEngine(CacheSize:integer):TXDBEngine;
begin
  result:=TMainEngine.Create(CacheSize);
end;

exports
       CreateXDBEngine;


begin
end.
